package
{
	import as3isolib.display.IsoView;
	import as3isolib.display.scene.IsoGrid;
	import as3isolib.display.scene.IsoScene;
	import as3isolib.geom.Pt;
	import as3isolib.graphics.Stroke;
	
	import com.bit101.components.PushButton;
	
	import eDpLib.events.ProxyEvent;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import objects.IsoSilla;
	import objects.IsoSimpleAsset;
	
	[SWF(width='539', height='400', backgroundColor='#ffffff', frameRate='12')]
	
	
	public class SimpleIsoDemo extends Sprite
	{
		private var viewPort:IsoView;
		private var scene:IsoScene;
		
		public function SimpleIsoDemo()
		{
			
			var buttonadd:PushButton = new PushButton(this, 20, 20, "Añadir silla", add_click_handler);
			
			var buttonrot:PushButton = new PushButton(this, 20, 50, "Rotar silla", rot_click_handler);
			
			setIso();
		}
		
		private function setIso():void
		{
			
			//creamos vista y la configuramos
			viewPort = new IsoView();
			viewPort.showBorder=false;
			viewPort.setSize(539, 400);
			addChild(viewPort);
			
			//creamos escena 
			scene = new IsoScene();
			//y la añadimos a la vista
			viewPort.addScene(scene);
			
			//creamos un grid y lo añadimos a la escena
			//para referencia
			var grid:IsoGrid = new IsoGrid();
			grid.setGridSize(5,5,0);
			grid.cellSize = 35;
			grid.showOrigin=true;
			grid.stroke = new Stroke(1,0x999999,1);
			scene.addChild(grid);
			
			//enterframe principal
			addEventListener(
				Event.ENTER_FRAME, 
				enterFrame_handler);	
		}
		
		private function enterFrame_handler(e:Event):void
		{
			//renderizamos escena
			scene.render();
		}
		
		
		public function rot_click_handler(e:MouseEvent):void
		{
			if(selectedObject)
			{
				selectedObject.changeView();
				selectObject(selectedObject);
			}
		}
		
		public function add_click_handler(e:MouseEvent):void
		{
			var o:IsoSimpleAsset = new IsoSilla();
			
			addObject(o);
			selectObject(o);
		}
		
		public function addObject(o:IsoSimpleAsset, activo:Boolean=true):void
		{
			scene.addChild(o);
			
			o.moveTo(170,170,100);
			o.addEventListener(MouseEvent.MOUSE_DOWN, pickup_handler);
		}
		
		
		private var selectedObject:IsoSimpleAsset=null;
		public function selectObject(o:IsoSimpleAsset):void
		{
			if(selectedObject!=null)
			{
				selectedObject.unselect();
			}
			
			o.select();
			
			selectedObject = o;
			
		}
		
		
		
		/**
		 * DRAG OBJECT
		 */
		
		private var dragPt:Pt;
		private var dragObject:IsoSimpleAsset;
		
		private function pickup_handler(e:Event):void
		{
			
			//almacenamos el elemento	
			dragObject = IsoSimpleAsset(e.target);
			
			//marcamos el elemento como seleccionado
			selectObject(dragObject);
			
			//almacenamos el punto
			//en coordenadas isométricas
			dragPt = viewPort.localToIso( new Pt(stage.mouseX, stage.mouseY) );
			
			//ajustamos punto
			//según la posición del elemento
			dragPt.x -= dragObject.x;
			dragPt.y -= dragObject.y;
			dragPt.z -= dragObject.z;
			
			//cleanup listener
			dragObject.removeEventListener(MouseEvent.MOUSE_DOWN, pickup_handler);
			
			
			//añadimos listeners necesarios
			//mouse up en el stage "por si"
			stage.addEventListener(MouseEvent.MOUSE_UP, drop_handler);
			//al mover el mouse
			viewPort.addEventListener(MouseEvent.MOUSE_MOVE, drag_handler);
			
		}
		
		private function drop_handler(e:Event):void
		{
			
			//clean up events
			stage.removeEventListener(MouseEvent.MOUSE_UP, drop_handler);
			viewPort.removeEventListener(MouseEvent.MOUSE_MOVE, drag_handler);
			
			//resetear drag
			dragObject.addEventListener(MouseEvent.MOUSE_DOWN, pickup_handler);
			
		}
		
		private function drag_handler(e:MouseEvent):void
		{
			//convertimos coordenadas del mouse a isométricas
			var pt:Pt = viewPort.localToIso( new Pt(stage.mouseX, stage.mouseY) );
			
			//calcular punto al que nos hemos desplazado
			var x_to:Number = Math.round(pt.x - dragPt.x);
			var y_to:Number = Math.round(pt.y - dragPt.y);
			
			//mover elemento
			dragObject.moveTo(x_to, y_to, dragObject.z);
			
		}
		
		/**
		 * END DRAG
		 */
		
		
	}//end class
}//end package